/*
 * CreatorUnitTest.hpp
 *
 *  Created on: Jan 03, 2011
 *      Author: heber
 */

#ifndef CREATORUNITTEST_HPP_
#define CREATORUNITTEST_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cppunit/extensions/HelperMacros.h>

#include "stubs/CreatorStub.hpp"
#include "stubs/CommonStub.hpp"

class CreatorTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( CreatorTest );
  CPPUNIT_TEST ( CreationTest );
  CPPUNIT_TEST ( IndividualityTest );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void CreationTest();
  void IndividualityTest();

private:
  class CreatorStub<teststubs::Aclass> teststubA;
  class CreatorStub<teststubs::Bclass> teststubB;
  ICreatorStub* testingA1;
  ICreatorStub* testingA2;
  ICreatorStub* testingB1;
  ICreatorStub* testingB2;
};

#endif /* CREATORUNITTEST_HPP_ */
