/*
 * ManipulableCloneUnitTest.hpp
 *
 *  Created on: Jan 06, 2011
 *      Author: heber
 */

#ifndef MANIPULABLECLONEUNITTEST_HPP_
#define MANIPULABLECLONEUNITTEST_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cppunit/extensions/HelperMacros.h>

#include "stubs/CommonStub.hpp"
#include "stubs/ManipulableCloneStub.hpp"
#include "stubs/CommonParametersStub.hpp"


class ManipulableCloneTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( ManipulableCloneTest );
  CPPUNIT_TEST ( CreationTest );
  CPPUNIT_TEST ( IndividualityTest );
  CPPUNIT_TEST ( ManipulationTest );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void CreationTest();
  void IndividualityTest();
  void ManipulationTest();

private:
  ManipulablePrototype<teststubs::Aclass> p1;
  ManipulablePrototype<teststubs::Bclass> p2;
  IManipulablePrototype *ip1;
  IManipulablePrototype *ip1_1;
  IManipulablePrototype *ip1_2;
  IManipulablePrototype *ip2;
  IManipulablePrototype *ip2_1;
  IManipulablePrototype *ip2_2;
};

#endif /* MANIPULABLECLONEUNITTEST_HPP_ */
