/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * CommonStub.cpp
 *
 *  Created on: Jan 4, 2011
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CommonStub.hpp"

namespace teststubs {
  Iclass::~Iclass() {};

  Aclass::Aclass() :
    counter(0)
  {};

  Aclass::~Aclass() {};

  void Aclass::count() {
    ++counter;
  }

  int Aclass::getcount() const {
    return counter;
  };

  void Aclass::setcount(int const _counter) {
    counter = _counter;
  };


  Bclass::Bclass() :
    counter(0.)
  {};

  Bclass::~Bclass() {};

  void Bclass::count() {
    counter+=1.;
  }

  int Bclass::getcount() const {
    return (int)counter;
  };

  void Bclass::setcount(int const _counter) {
    counter = (double)_counter;
  };
};
