/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * ManipulableCloneStub.cpp
 *
 *  Created on: Jan 6, 2011
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CommonStub.hpp"
#include "CommonParametersStub.hpp"
#include "ManipulableCloneStub.hpp"

/************ Prototype 1 *******************/

template <>
IManipulablePrototype* ManipulablePrototype<teststubs::Aclass>::clone() const
{
  IManipulablePrototype *MyManipulableClone = new ManipulablePrototype<teststubs::Aclass>();
  MyManipulableClone->setcount(getcount());
  return MyManipulableClone;
}

template <>
ManipulablePrototype<teststubs::Aclass>* ManipulablePrototype<teststubs::Aclass>::manipulatedclone(const teststubs::classParameters &_params) const
{
  ManipulablePrototype<teststubs::Aclass> *MyManipulableClone = new ManipulablePrototype<teststubs::Aclass>();
  MyManipulableClone->setcount(_params.counter);
  return MyManipulableClone;
}

/************ Prototype 2 *******************/

template <>
IManipulablePrototype* ManipulablePrototype<teststubs::Bclass>::clone() const
{
  IManipulablePrototype *MyManipulableClone = new ManipulablePrototype<teststubs::Bclass>();
  MyManipulableClone->setcount(getcount());
  return MyManipulableClone;
}

template <>
ManipulablePrototype<teststubs::Bclass>* ManipulablePrototype<teststubs::Bclass>::manipulatedclone(const teststubs::classParameters &_params) const
{
  ManipulablePrototype<teststubs::Bclass> *MyManipulableClone = new ManipulablePrototype<teststubs::Bclass>();
  MyManipulableClone->setcount(_params.counter);
  return MyManipulableClone;
}
