/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * ManipulablePrototypeFactoryStub.cpp
 *
 *  Created on: Jan 6, 2011
   Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/Singleton_impl.hpp"

#include "CommonStub.hpp"
#include "CommonParametersStub.hpp"
#include "ManipulablePrototypeFactoryStub.hpp"

// has to be included BEFORE ManipulablePrototypeFactory_impl.hpp!
#include "ManipulablePrototypeFactoryStub.def"
#include "CodePatterns/ManipulablePrototypeFactory_impl.hpp"


ManipulablePrototypeFactoryStub::ManipulablePrototypeFactoryStub() {
  FillPrototypeTable();
}

ManipulablePrototypeFactoryStub::~ManipulablePrototypeFactoryStub() {
  EmptyPrototypeTable();
}

CONSTRUCT_SINGLETON(ManipulablePrototypeFactoryStub)
CONSTRUCT_MANIPULABLEPROTOTYPEFACTORY(IManipulablePrototype, teststubs::classParameters)

#include "ManipulablePrototypeFactoryStub.undef"
