/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * PrototypeFactoryStub.cpp
 *
 *  Created on: Jan 4, 2011
   Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/Singleton_impl.hpp"

#include "CommonStub.hpp"
#include "PrototypeFactoryStub.hpp"

// has to be included BEFORE PrototypeFactory_impl.hpp!
#include "PrototypeFactoryStub.def"
#include "CodePatterns/PrototypeFactory_impl.hpp"


PrototypeFactoryStub::PrototypeFactoryStub() {
  FillPrototypeTable();
}

PrototypeFactoryStub::~PrototypeFactoryStub() {
  EmptyPrototypeTable();
}

CONSTRUCT_SINGLETON(PrototypeFactoryStub)
CONSTRUCT_PROTOTYPEFACTORY(IPrototype)

#include "PrototypeFactoryStub.undef"
